public inbox for gentoo-commits@lists.gentoo.org
 help / color / mirror / Atom feed
From: "Joonas Niilola" <juippis@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: media-gfx/freecad/
Date: Mon, 15 Feb 2021 09:04:03 +0000 (UTC)	[thread overview]
Message-ID: <1613379833.e05f68215cf3a932447ffb3f0c3f066e4998c178.juippis@gentoo> (raw)

commit:     e05f68215cf3a932447ffb3f0c3f066e4998c178
Author:     Bernd Waibel <waebbl <AT> gmail <DOT> com>
AuthorDate: Sat Jan 16 00:58:17 2021 +0000
Commit:     Joonas Niilola <juippis <AT> gentoo <DOT> org>
CommitDate: Mon Feb 15 09:03:53 2021 +0000
URL:        https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=e05f6821

media-gfx/freecad: add live ebuild

Fix email in metadata.xml

Package-Manager: Portage-3.0.13, Repoman-3.0.2
Signed-off-by: Bernd Waibel <waebbl-gentoo <AT> posteo.net>
Closes: https://github.com/gentoo/gentoo/pull/19076
Signed-off-by: Joonas Niilola <juippis <AT> gentoo.org>

 media-gfx/freecad/freecad-9999.ebuild | 283 ++++++++++++++++++++++++++++++++++
 media-gfx/freecad/metadata.xml        |   2 +-
 2 files changed, 284 insertions(+), 1 deletion(-)

diff --git a/media-gfx/freecad/freecad-9999.ebuild b/media-gfx/freecad/freecad-9999.ebuild
new file mode 100644
index 00000000000..e2cb13d51fc
--- /dev/null
+++ b/media-gfx/freecad/freecad-9999.ebuild
@@ -0,0 +1,283 @@
+# Copyright 1999-2021 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=7
+
+# vtk needs updating to use 3.9
+PYTHON_COMPAT=( python3_{7,8} )
+
+inherit check-reqs cmake desktop optfeature python-single-r1 xdg
+
+DESCRIPTION="QT based Computer Aided Design application"
+HOMEPAGE="https://www.freecadweb.org/ https://github.com/FreeCAD/FreeCAD"
+
+if [[ ${PV} = *9999 ]]; then
+	inherit git-r3
+	EGIT_REPO_URI="https://github.com/FreeCAD/FreeCAD.git"
+	S="${WORKDIR}/freecad-${PV}"
+else
+	COMMIT=82ec99dbc1f0f054748059ae8bb138eb44b43073
+	SRC_URI="https://github.com/FreeCAD/FreeCAD/archive/${COMMIT}.tar.gz -> ${P}.tar.gz"
+	KEYWORDS="~amd64"
+	S="${WORKDIR}/FreeCAD-${COMMIT}"
+fi
+
+# code is licensed LGPL-2
+# examples are licensed CC-BY-SA (without note of specific version)
+LICENSE="LGPL-2 CC-BY-SA-4.0"
+SLOT="0"
+IUSE="ccache debug headless pcl test"
+RESTRICT="!test? ( test )"
+
+FREECAD_EXPERIMENTAL_MODULES="cloud plot ship"
+FREECAD_STABLE_MODULES="addonmgr arch drawing fem idf image
+	inspection material mesh openscad part-design path points
+	raytracing robot show spreadsheet surface techdraw tux"
+
+for module in ${FREECAD_STABLE_MODULES}; do
+	IUSE="${IUSE} +${module}"
+done
+for module in ${FREECAD_EXPERIMENTAL_MODULES}; do
+	IUSE="${IUSE} -${module}"
+done
+unset module
+
+RDEPEND="
+	${PYTHON_DEPS}
+	>=dev-cpp/eigen-3.3.1:3
+	dev-libs/OpenNI2[opengl(+)]
+	dev-libs/libspnav[X]
+	dev-libs/xerces-c
+	dev-qt/designer:5
+	dev-qt/qtconcurrent:5
+	dev-qt/qtcore:5
+	dev-qt/qtgui:5
+	dev-qt/qtnetwork:5
+	dev-qt/qtopengl:5
+	dev-qt/qtprintsupport:5
+	dev-qt/qtsvg:5
+	dev-qt/qtwebengine:5[widgets]
+	dev-qt/qtwidgets:5
+	dev-qt/qtx11extras:5
+	dev-qt/qtxml:5
+	>=media-libs/coin-4.0.0
+	media-libs/freetype
+	media-libs/qhull
+	sci-libs/flann[openmp]
+	>=sci-libs/med-4.0.0-r1[python,${PYTHON_SINGLE_USEDEP}]
+	sci-libs/opencascade:=[vtk(+)]
+	sci-libs/orocos_kdl:=
+	sys-libs/zlib
+	virtual/glu
+	virtual/libusb:1
+	virtual/opengl
+	cloud? (
+		dev-libs/openssl:=
+		net-misc/curl
+	)
+	fem? ( <sci-libs/vtk-9[boost,python,qt5,rendering,${PYTHON_SINGLE_USEDEP}] )
+	mesh? ( sci-libs/hdf5:=[fortran,zlib] )
+	openscad? ( media-gfx/openscad )
+	pcl? ( >=sci-libs/pcl-1.8.1:=[opengl,openni2(+),qt5(+),vtk(+)] )
+	$(python_gen_cond_dep '
+		dev-libs/boost:=[python,threads,${PYTHON_MULTI_USEDEP}]
+		dev-python/matplotlib[${PYTHON_MULTI_USEDEP}]
+		dev-python/numpy[${PYTHON_MULTI_USEDEP}]
+		>=dev-python/pivy-0.6.5[${PYTHON_MULTI_USEDEP}]
+		dev-python/pyside2[gui,svg,${PYTHON_MULTI_USEDEP}]
+		dev-python/shiboken2[${PYTHON_MULTI_USEDEP}]
+		addonmgr? ( dev-python/GitPython[${PYTHON_MULTI_USEDEP}] )
+		mesh? ( dev-python/pybind11[${PYTHON_MULTI_USEDEP}] )
+	')
+"
+DEPEND="${RDEPEND}"
+BDEPEND="
+	dev-lang/swig
+	ccache? ( dev-util/ccache )
+"
+
+# To get required dependencies:
+# 'grep REQUIRES_MODS cMake/FreeCAD_Helpers/CheckInterModuleDependencies.cmake'
+# We set the following requirements by default:
+# draft, import, part, qt5, sketcher, start, web.
+#
+# Additionally if mesh is set, we auto-enable mesh_part, flat_mesh and smesh
+# Fem actually needs smesh, but as long as we don't have a smesh package, we enable
+# smesh through the mesh USE flag. Note however, the fem<-smesh dependency isn't
+# reflected by the REQUIRES_MODS macro, but at
+# cMake/FreeCAD_Helpers/InitializeFreeCADBuildOptions.cmake:187.
+REQUIRED_USE="
+	${PYTHON_REQUIRED_USE}
+	arch? ( mesh )
+	debug? ( mesh )
+	drawing? ( spreadsheet )
+	fem? ( mesh )
+	inspection? ( mesh points )
+	openscad? ( mesh )
+	path? ( mesh robot )
+	ship? ( image plot )
+	techdraw? ( spreadsheet drawing )
+"
+
+PATCHES=(
+	"${FILESDIR}"/${PN}-0.19_pre20201231-0001-FindCoin3DDoc.cmake-fix-patch-for-coin-docs.patch
+	"${FILESDIR}"/${PN}-0.19_pre20201231-0002-CMakeLists.txt-add-option-for-ccache.patch
+)
+
+DOCS=( README.md ChangeLog.txt CODE_OF_CONDUCT.md )
+
+CHECKREQS_DISK_BUILD="7G"
+
+pkg_setup() {
+	check-reqs_pkg_setup
+	python-single-r1_pkg_setup
+	[[ -z ${CASROOT} ]] && die "\${CASROOT} not set, plesae run eselect opencascade"
+}
+
+src_prepare() {
+	# the upstream provided file doesn't find the coin doc tag file,
+	# but cmake ships a working one, so we use this.
+	rm "${S}/cMake/FindCoin3D.cmake" || die
+
+	# Fix OpenCASCADE lookup
+	sed -e 's|/usr/include/opencascade|${CASROOT}/include/opencascade|' \
+		-e 's|/usr/lib|${CASROOT}/'$(get_libdir)' NO_DEFAULT_PATH|' \
+		-i cMake/FindOpenCasCade.cmake || die
+
+	# Fix desktop file
+	sed -e 's/Exec=FreeCAD/Exec=freecad/' -i src/XDGData/org.freecadweb.FreeCAD.desktop || die
+
+	cmake_src_prepare
+}
+
+src_configure() {
+	local mycmakeargs=(
+		-DBUILD_ADDONMGR=$(usex addonmgr)
+		-DBUILD_ARCH=$(usex arch)
+		-DBUILD_ASSEMBLY=OFF
+		-DBUILD_CLOUD=$(usex cloud)
+		-DBUILD_COMPLETE=OFF					# deprecated
+		-DBUILD_DRAFT=ON						# basic workspace, enable it by default
+		-DBUILD_DRAWING=$(usex drawing)
+		-DBUILD_ENABLE_CXX_STD:STRING="C++14"	# needed for >=boost-1.75.0
+		-DBUILD_FEM=$(usex fem)
+		-DBUILD_FEM_NETGEN=OFF
+		-DBUILD_FLAT_MESH=$(usex mesh)
+		-DBUILD_FORCE_DIRECTORY=ON				# force building in a dedicated directory
+		-DBUILD_FREETYPE=ON						# automagic dep
+		-DBUILD_GUI=$(usex !headless)
+		-DBUILD_IDF=$(usex idf)
+		-DBUILD_IMAGE=$(usex image)
+		-DBUILD_IMPORT=ON						# import module for various file formats
+		-DBUILD_INSPECTION=$(usex inspection)
+		-DBUILD_JTREADER=OFF					# code has been removed upstream, but option is still there
+		-DBUILD_MATERIAL=$(usex material)
+		-DBUILD_MESH=$(usex mesh)
+		-DBUILD_MESH_PART=$(usex mesh)
+		-DBUILD_OPENSCAD=$(usex openscad)
+		-DBUILD_PART=ON							# basic workspace, enable it by default
+		-DBUILD_PART_DESIGN=$(usex part-design)
+		-DBUILD_PATH=$(usex path)
+		-DBUILD_PLOT=$(usex plot)				# conflicts with possible external workbench
+		-DBUILD_POINTS=$(usex points)
+		-DBUILD_QT5=ON							# OFF means to use Qt4
+		-DBUILD_RAYTRACING=$(usex raytracing)
+		-DBUILD_REVERSEENGINEERING=OFF			# currently only an empty sandbox
+		-DBUILD_ROBOT=$(usex robot)
+		-DBUILD_SHIP=$(usex ship)				# conflicts with possible external workbench
+		-DBUILD_SHOW=$(usex show)
+		-DBUILD_SKETCHER=ON						# needed by draft workspace
+		-DBUILD_SMESH=$(usex mesh)
+		-DBUILD_SPREADSHEET=$(usex spreadsheet)
+		-DBUILD_START=ON						# basic workspace, enable it by default
+		-DBUILD_SURFACE=$(usex surface)
+		-DBUILD_TECHDRAW=$(usex techdraw)
+		-DBUILD_TUX=$(usex tux)
+		-DBUILD_VR=OFF
+		-DBUILD_WEB=ON							# needed by start workspace
+		-DBUILD_WITH_CONDA=OFF
+
+		-DCMAKE_INSTALL_DATADIR=/usr/share/${PN}/data
+		-DCMAKE_INSTALL_DOCDIR=/usr/share/doc/${PF}
+		-DCMAKE_INSTALL_INCLUDEDIR=/usr/include/${PN}
+		-DCMAKE_INSTALL_PREFIX=/usr/$(get_libdir)/${PN}
+
+		-DFREECAD_BUILD_DEBIAN=OFF
+
+		-DFREECAD_USE_CCACHE=$(usex ccache)
+		-DFREECAD_USE_EXTERNAL_KDL=ON
+		-DFREECAD_USE_EXTERNAL_SMESH=OFF		# no package in Gentoo
+		-DFREECAD_USE_EXTERNAL_ZIPIOS=OFF		# doesn't work yet, also no package in Gentoo tree
+		-DFREECAD_USE_FREETYPE=ON
+		-DFREECAD_USE_OCC_VARIANT:STRING="Official Version"
+		-DFREECAD_USE_PCL=$(usex pcl)
+		-DFREECAD_USE_PYBIND11=$(usex mesh)
+		-DFREECAD_USE_QT_FILEDIALOG=ON
+		-DFREECAD_USE_QTWEBMODULE:STRING="Qt WebEngine"
+
+		-DOCC_INCLUDE_DIR="${CASROOT}"/include/opencascade
+		-DOCC_LIBRARY_DIR="${CASROOT}"/$(get_libdir)
+		-DOCCT_CMAKE_FALLBACK=ON				# don't use occt-config which isn't included in opencascade for Gentoo
+	)
+
+	if use debug; then
+		mycmakeargs+=(
+			# sandbox needs mesh support
+			-DBUILD_SANDBOX=$(usex mesh)
+			-DBUILD_TEMPLATE=ON
+			-DBUILD_TEST=ON
+		)
+	else
+		mycmakeargs+=(
+			-DBUILD_SANDBOX=OFF
+			-DBUILD_TEMPLATE=OFF
+			-DBUILD_TEST=OFF
+		)
+	fi
+
+	cmake_src_configure
+}
+
+src_install() {
+	cmake_src_install
+
+	if ! use headless; then
+		dosym ../$(get_libdir)/${PN}/bin/FreeCAD /usr/bin/freecad
+		mv "${ED}"/usr/$(get_libdir)/freecad/share/* "${ED}"/usr/share || die "failed to move shared ressources"
+	fi
+	dosym ../$(get_libdir)/${PN}/bin/FreeCADCmd /usr/bin/freecadcmd
+
+	python_optimize "${ED}"/usr/share/${PN}/data/Mod/ "${ED}"/usr/$(get_libdir)/${PN}{/Ext,/Mod}/
+}
+
+pkg_postinst() {
+	xdg_pkg_postinst
+
+	if use plot; then
+		einfo "Note: You are enabling the 'plot' USE flag."
+		einfo "This conflicts with the plot workbench that can be loaded"
+		einfo "via the addon manager! You can only install one of those."
+	fi
+
+	if use ship; then
+		einfo "Note: You are enabling the 'ship' USE flag."
+		einfo "This conflicts with the ship workbench that can be loaded"
+		einfo "via the addon manager! You can only install one of those."
+	fi
+
+	einfo "You can load a lot of additional workbenches using the integrated"
+	einfo "AddonManager."
+
+	einfo "There are a lot of additional tools, for which FreeCAD has builtin"
+	einfo "support. Some of them are available in Gentoo. Take a look at"
+	einfo "https://wiki.freecadweb.org/Installing#External_software_supported_by_FreeCAD"
+	optfeature "interact with git repositories" dev-python/GitPython
+	optfeature "work with COLLADA documents" dev-python/pycollada
+	optfeature "dependency graphs" media-gfx/graphviz
+	optfeature "PBR Rendering" media-gfx/povray
+	optfeature "FEM mesh generator" sci-libs/gmsh
+}
+
+pkg_postrm() {
+	xdg_pkg_postrm
+}

diff --git a/media-gfx/freecad/metadata.xml b/media-gfx/freecad/metadata.xml
index a36a8d876fb..599d1643a22 100644
--- a/media-gfx/freecad/metadata.xml
+++ b/media-gfx/freecad/metadata.xml
@@ -2,7 +2,7 @@
 <!DOCTYPE pkgmetadata SYSTEM "http://www.gentoo.org/dtd/metadata.dtd">
 <pkgmetadata>
 	<maintainer type="person">
-		<email>waebbl@gmail.com</email>
+		<email>waebbl-gentoo@posteo.net</email>
 		<name>Bernd Waibel</name>
 	</maintainer>
 	<maintainer type="project">


             reply	other threads:[~2021-02-15  9:04 UTC|newest]

Thread overview: 130+ messages / expand[flat|nested]  mbox.gz  Atom feed  top
2021-02-15  9:04 Joonas Niilola [this message]
  -- strict thread matches above, loose matches on Subject: below --
2025-03-02 19:42 [gentoo-commits] repo/gentoo:master commit in: media-gfx/freecad/ Sam James
2025-03-02 19:42 Sam James
2025-01-10 16:43 Nowa Ammerlaan
2024-12-20 16:09 Nowa Ammerlaan
2024-12-01 16:15 Sam James
2024-12-01 16:04 Sam James
2024-11-27 23:26 Sam James
2024-11-25 15:32 Andreas Sturmlechner
2024-11-25 15:32 Andreas Sturmlechner
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-24 20:25 Sam James
2024-11-23 19:40 Andreas Sturmlechner
2024-11-22 18:39 Joonas Niilola
2024-11-20 10:31 Nowa Ammerlaan
2024-10-11  9:36 Andrew Ammerlaan
2024-09-30 13:37 Andrew Ammerlaan
2024-09-23  9:01 Andrew Ammerlaan
2024-09-15 15:42 Andrew Ammerlaan
2024-09-14 19:59 Alexey Shvetsov
2024-04-15  9:42 Andrew Ammerlaan
2024-04-15  8:38 Joonas Niilola
2024-03-27  2:57 Sam James
2024-03-24 13:54 Andrew Ammerlaan
2024-03-23 11:21 Andrew Ammerlaan
2024-03-09 10:17 Andrew Ammerlaan
2024-03-09  7:23 Andrew Ammerlaan
2024-01-05 13:12 Andrew Ammerlaan
2024-01-05 10:23 Andrew Ammerlaan
2023-11-25  9:11 Miroslav Šulc
2023-11-20 19:43 Andrew Ammerlaan
2023-05-08  8:19 Joonas Niilola
2023-05-08  8:19 Joonas Niilola
2023-05-07  8:44 Joonas Niilola
2023-02-23 17:30 Miroslav Šulc
2023-02-23 11:25 Andrew Ammerlaan
2023-02-21  6:18 Joonas Niilola
2023-01-09 19:23 Joonas Niilola
2022-11-27 13:23 Piotr Karbowski
2022-11-22 15:03 Joonas Niilola
2022-09-28  9:55 Joonas Niilola
2022-09-02 16:50 Joonas Niilola
2022-08-31  4:57 Joonas Niilola
2022-07-29  3:16 Sam James
2022-07-09 12:26 Matthew Smith
2022-05-19 12:12 Joonas Niilola
2022-04-18 11:35 Joonas Niilola
2022-04-14  8:54 Joonas Niilola
2022-04-06 17:30 Piotr Karbowski
2022-04-02 12:58 Andreas Sturmlechner
2022-02-03 15:52 John Helmert III
2022-01-28  8:24 Sam James
2022-01-10  1:04 Sam James
2022-01-10  1:04 Sam James
2021-12-04 21:52 Sam James
2021-12-04 21:52 Sam James
2021-11-30 12:50 Joonas Niilola
2021-11-30 12:50 Joonas Niilola
2021-11-02 10:04 Sam James
2021-11-02 10:04 Sam James
2021-07-10  9:17 Ionen Wolkens
2021-06-21 22:26 Sam James
2021-06-21 22:26 Sam James
2021-06-21 22:26 Sam James
2021-06-18 19:18 David Seifert
2021-06-16 14:02 Sam James
2021-06-15 14:42 Sam James
2021-06-05 14:14 Andrew Ammerlaan
2021-06-05 11:56 Andrew Ammerlaan
2021-06-03 19:15 Sam James
2021-05-31 19:26 Alexey Shvetsov
2021-05-31 19:26 Alexey Shvetsov
2021-05-24 12:30 Andrew Ammerlaan
2021-05-06 21:45 Sam James
2021-05-06 21:45 Sam James
2021-03-16 17:12 Michał Górny
2021-03-14 11:41 Joonas Niilola
2018-05-11 19:36 Andreas Sturmlechner
2018-03-13  9:33 Andreas Sturmlechner
2018-03-13  9:33 Andreas Sturmlechner
2018-03-13  9:33 Andreas Sturmlechner
2018-03-13  9:33 Andreas Sturmlechner
2018-03-02 22:08 Andreas Sturmlechner
2018-03-02 22:08 Andreas Sturmlechner
2018-03-02 22:08 Andreas Sturmlechner
2018-03-02 22:08 Andreas Sturmlechner
2018-01-05  0:35 Andreas Sturmlechner
2017-12-29 19:06 Miroslav Šulc
2017-12-29 19:06 Miroslav Šulc
2017-11-06  1:58 Andreas Sturmlechner
2017-11-06  1:58 Andreas Sturmlechner
2017-11-06  1:58 Andreas Sturmlechner
2017-11-06  1:58 Andreas Sturmlechner
2017-07-26 17:08 Alexey Shvetsov
2017-07-26 17:08 Alexey Shvetsov
2017-07-26 17:08 Alexey Shvetsov
2017-04-30 19:46 Davide Pesavento
2017-04-13 19:33 Patrice Clement
2017-01-20 14:21 David Seifert
2017-01-18 21:19 David Seifert
2017-01-18 21:19 David Seifert
2016-02-20 12:45 Michael Weber
2015-09-18 15:26 Michael Weber
2015-08-11  9:32 Michael Weber
2015-08-11  9:18 Michael Weber
2015-08-11  9:08 Michael Weber
2015-08-11  9:08 Michael Weber
2015-08-11  6:18 Michael Weber
2015-08-09 14:03 Michael Weber

Reply instructions:

You may reply publicly to this message via plain-text email
using any one of the following methods:

* Save the following mbox file, import it into your mail client,
  and reply-to-all from there: mbox

  Avoid top-posting and favor interleaved quoting:
  https://en.wikipedia.org/wiki/Posting_style#Interleaved_style

* Reply using the --to, --cc, and --in-reply-to
  switches of git-send-email(1):

  git send-email \
    --in-reply-to=1613379833.e05f68215cf3a932447ffb3f0c3f066e4998c178.juippis@gentoo \
    --to=juippis@gentoo.org \
    --cc=gentoo-commits@lists.gentoo.org \
    --cc=gentoo-dev@lists.gentoo.org \
    /path/to/YOUR_REPLY

  https://kernel.org/pub/software/scm/git/docs/git-send-email.html

* If your mail client supports setting the In-Reply-To header
  via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox